<script setup lang="ts">
import { onMounted } from 'vue'
import { nextTick, ref } from 'vue'
import type { Branch } from '@/types/Branch'
import type { VForm } from 'vuetify/components'
import { useLoadingStore } from '@/stores/loading'
import { useBranchStore } from '@/stores/branch'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    value: 'name',
    key: 'name'
  },
  {
    title: 'Maneger',
    value: 'maneger',
    key: 'maneger'
  },
  {
    title: 'Address',
    value: 'address',
    key: 'address'
  },
  {
    title: 'Tels',
    value: 'tels',
    key: 'tels'
  },
  { key: 'actions', sortable: false }
]

const branchStore = useBranchStore()

const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)

let editedIndex = -1

function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    branchStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await branchStore.deleteBranch()
  closeDelete()
}

async function editItem(item: Branch) {
  if (!item.id) return
  await branchStore.getBranch(item.id)
  dialog.value = true
}

async function deleteItem(item: Branch) {
  if (!item.id) return
  await branchStore.getBranch(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

onMounted(() => {
  branchStore.getBranchs()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    branchStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await branchStore.saveBranch()
  closeDialog()
}
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="branchStore.branchs" class="custom-datatable">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white">Branch</v-toolbar-title>
          <v-btn icon="mdi-cached" style="color: white" @click="branchStore.getBranchs"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-spacer></v-spacer>

          <!-- Put Edited  Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New Branch
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Branch Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                          v-model="branchStore.editedBranch.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="branchStore.editedBranch.maneger"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Maneger"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="branchStore.editedBranch.address"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Address"
                          placeholder="Enter your address"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="branchStore.editedBranch.tels"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Tels"
                          placeholder="Enter your tels"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this user?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="rgb(214, 175, 125)" @click="branchStore.getBranchs"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<style>
.custom-datatable th {
  background-color: rgb(236, 235, 235);
  color: black;
  font-weight: bold !important; 
  font-size: 15px; /* Adjust the font size as needed */
}
</style>
